#ifndef _KEYLIST_H_
#define _KEYLIST_H_

#include "types.h"

// Very low-level stuff, no STL.

struct Key {
  int no;
  byte* key;
  int keyLen;
  short* hashKey;
  short* sortedHashKey;
  int hashKeyLen;
  byte* charSet;
  char* data;
  int freq;
  uint hash;
  Key* collision; 
  // no ctors or dtors
  void init(int, const char*, int, const char*);
  void free();
};

// Used only as a base for HashGenerator. 

class KeyList {
protected: 
  KeyList() { init(); }
  ~KeyList() { clear(); }
  void init();
  void clear();
  void add(const char* aKey, int aLen, const char* aData);
  Key* keys; 
  Key* end;
  int keyCount;
  int keyAlloc;
  int minKeyLen;
  int maxKeyLen;
};

#endif

