#include "opthash.h"

OptionLookup optionLookup;

unsigned char OptionLookup::hash[35] = {
  // Hash table. Each element either points to a key table entry,
  // or is null (27) if there is no key with this hash value.
  /*  0 */                      26,  1,  8, 11, 14,
  /* 10 */   7,  9,  2,  3,  0, 19, 16,  4,  6, 10,
  /* 20 */  17, 27, 15,  5, 27, 23, 27, 12, 18, 25,
  /* 30 */  27, 22, 21, 27, 13, 27, 27, 24, 27, 20
};

unsigned char OptionLookup::weight[255] = {
  // Weight table (one character hash function).
  /*   0 */       0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  10 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  20 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  30 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  40 */   0,  0,  0,  0,  0,  6,  0,  0,  0,  0,
  /*  50 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  60 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  70 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  80 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /*  90 */   0,  0,  0,  0,  0,  0,  0,  0, 12, 11,
  /* 100 */   0,  0,  4,  0,  1,  5,  0,  1,  0,  1,
  /* 110 */   2,  0,  1,  0,  0,  4, 15,  5,  0,  7,
  /* 120 */   0,  0,  3,  0,  0,  0,  0,  0,  0,  0,
  /* 130 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 140 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 150 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 160 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 170 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 180 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 190 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 200 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 210 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 220 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 230 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 240 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  /* 250 */   0,  0,  0,  0,  0,  0
};

OptionEntry OptionLookup::key[27] = {
  // Key table. Holds keys and associated data (order preserved.)
  /*  0 */  { "optimize-hits",          optOptimizeHits },
  /*  1 */  { "random",                 optRandom },
  /*  2 */  { "randomize",              optRandomize },
  /*  3 */  { "size",                   optSize },
  /*  4 */  { "length-switch",          optLengthSwitch },
  /*  5 */  { "min-expected-char",      optMinExpectedChar },
  /*  6 */  { "max-expected-char",      optMaxExpectedChar },
  /*  7 */  { "source",                 optSource },
  /*  8 */  { "header",                 optHeader },
  /*  9 */  { "output",                 optOutput },
  /* 10 */  { "test",                   optTest },
  /* 11 */  { "language",               optLanguage },
  /* 12 */  { "namespace-name",         optNamespaceName },
  /* 13 */  { "entry-struct-name",      optEntryStructName },
  /* 14 */  { "key-name",               optKeyName },
  /* 15 */  { "lookup-struct-name",     optLookupStructName },
  /* 16 */  { "lookup-data-name",       optLookupDataName },
  /* 17 */  { "lookup-func-name",       optLookupFuncName },
  /* 18 */  { "hash-table-name",        optHashTabName },
  /* 19 */  { "key-table-name",         optKeyTabName },
  /* 20 */  { "weight-table-name",      optWeightTabName },
  /* 21 */  { "length-table-name",      optLengthTabName },
  /* 22 */  { "collision-table-name",   optCollisionTabName },
  /* 23 */  { "inline-lookup-func",     optInlineLookupFunc },
  /* 24 */  { "static-lookup-data",     optStaticLookupData },
  /* 25 */  { "include-string-h",       optIncludeString },
  /* 26 */  { "debug",                  optDebug }
};



